Index: trunk/tools/nc_var_tools.py
===================================================================
--- trunk/tools/nc_var_tools.py	(revision 746)
+++ trunk/tools/nc_var_tools.py	(revision 747)
@@ -601,5 +601,5 @@
                   ncf = NetCDFFile(ncfile,'a')
 
-    return
+  return
 
 def chvarname(values, ncfile, varn):
@@ -1877,5 +1877,5 @@
                 self.dimx=self.dims[3]
 
-    return
+        return
 
 def subyrs(values, ncfile, varn):
@@ -3319,7 +3319,4 @@
     return loadvar
 
-AQUI AQUI AQUI AQUI AQUI AQUI AQUI
-
-
 def fill_ncvariable_lastdims(ncf, varn, prevdims, Nlastdims, fillvals):
     """ Function to fill the last [Nlastdims] dimensions of a variable [varn] from a netCDF object at the other dimensions at [prevdims]
@@ -3393,4 +3390,6 @@
         quit(-1)
 
+    return
+
 def maskvar(values, filename, varn):
     """ Function to mask a variable using a mask. It is assumed that mask[...,dimM,dimJ,dimK] and 
@@ -3540,75 +3539,5 @@
     print 'masked file "' + ofile + '" generated !!!'
 
-def lonlat2D(ncfobj, lonn, latn):
-    """ Function to create 2D matricies of longitudes and latitudes from the file
-    ncfobj= netCDF object file
-    lonn= longitude name
-    latn= latitude name
-    """
-    fname='lonlat2D'
-
-    lonvar = ncfobj.variables[lonn]
-    latvar = ncfobj.variables[latn]
-
-    loninf = variable_inf(lonvar)
-    latinf = variable_inf(latvar)
-
-    if loninf.Ndims == 1:
-        lonv = lonvar[:]
-        latv = latvar[:]
-        dx=loninf.dims[0]
-        dy=latinf.dims[0]
-        lonval = np.zeros((dy, dx), dtype=float)    
-        latval = np.zeros((dy, dx), dtype=float)    
-        for iy in range(dy):
-            lonval[iy,:] = lonv
-        for ix in range(dx):
-            latval[:,ix] = latv
-    elif loninf.Ndims == 2:
-        lonval = lonvar[:]
-        latval = latvar[:]
-    elif loninf.Ndims == 3:
-        lonval = lonvar[0,:,:]
-        latval = latvar[0,:,:]
-    else:
-        print errormsg
-        print '  ' + fname + ' dimension ', lonvar.Ndims, ' of the lon/lat matrices not ready !!!!'
-
-    return lonval, latval
-
-def indices_mask(mask):
-    """ Function to retrieve the indices from a 2D mask
-    mask= 2D mask matrix
-    mat=np.array(range(100), dtype=float).reshape((10,10))
-    >>> mask1= mat >= 45. 
-    >>> mask2= mat <= 55.
-    >>> mask = mask1 * mask2
-    indices_mask(mask)
-    [[4 5]
-    [4 6]
-    [4 7]
-    [4 8]
-    [4 9]
-    [5 0]
-    [5 1]
-    [5 2]
-    [5 3]
-    [5 4]
-    [5 5]]
-    """
-    dy=mask.shape[0]
-    dx=mask.shape[1]
-
-    Nptmask = np.sum(mask)
-    maskindices = np.zeros((Nptmask,2), dtype=int)
-    ij=0
-    for j in range(dy):
-        for i in range(dx):
-            if mask[j,i] == True:
-                maskindices[ij,0] = j
-                maskindices[ij,1] = i
-                ij = ij + 1
-
-    return maskindices
+    return
 
 def chgtimestep(values, origfile, varN):
@@ -3691,4 +3620,6 @@
     ncofile.close()
 
+    return
+
 def uploading_timestep(ncfile, varN, time_step):
     """ Function to upload a given time-step of a variable inside a netCDF
@@ -3847,77 +3778,5 @@
     fileobj.close()
 
-def typemod(value, typeval):
-    """ Function to give back a value in a given dtype
-    >>> print(typemod(8.2223, 'np.float64'))
-    <type 'numpy.float64'>
-    >>> print(typemod(8.2223, 'tuple'))
-    <type 'tuple'>
-    """
-    fname='typemod'
-
-    if typeval == 'int':
-        return int(value)
-    elif typeval == 'long':
-        return long(value)
-    elif typeval == 'float':
-        return float(value)
-    elif typeval == 'complex':
-        return complex(value)
-    elif typeval == 'str':
-        return str(value)
-    elif typeval == 'bool':
-        return bool(value)
-    elif typeval == 'list':
-        newval = []
-        newval.append(value)
-        return newval
-    elif typeval == 'dic':
-        newval = {}
-        newval[value] = value
-        return newval
-    elif typeval == 'tuple':
-        newv = []
-        newv.append(value)
-        newval = tuple(newv)
-        return newval
-    elif typeval == 'np.int8':
-        return np.int8(value)
-    elif typeval == 'np.int16':
-        return np.int16(value)
-    elif typeval == 'np.int32':
-        return np.int32(value)
-    elif typeval == 'np.int64':
-        return np.int64(value)
-    elif typeval == 'np.uint8':
-        return np.uint8(value)
-    elif typeval == 'np.uint16':
-        return np.uint16(value)
-    elif typeval == 'np.np.uint32':
-        return np.uint32(value)
-    elif typeval == 'np.uint64':
-        return np.uint64(value)
-    elif typeval == 'np.float':
-        return np.float(value)
-    elif typeval == 'np.float16':
-        return np.float16(value)
-    elif typeval == 'np.float32':
-        return np.float32(value)
-    elif typeval == 'float32':
-        return np.float32(value)
-    elif typeval == 'np.float64':
-        return np.float64(value)
-    elif typeval == 'float64':
-        return np.float64(value)
-    elif typeval == 'np.complex':
-        return np.complex(value)
-    elif typeval == 'np.complex64':
-        return np.complex64(value)
-    elif typeval == 'np.complex128':
-        return np.complex128(value)
-    else:
-        print errormsg
-        print fname + ':  data type "' + typeval + '" is not ready !'
-        print errormsg
-        quit(-1)
+    return
 
 def addvals(values, filename, varN):
@@ -4098,4 +3957,6 @@
         quit(-1)    
 
+    return
+
 def TimeInf(filename, tname):
     """ Function to print all the information from the variable time
@@ -4108,4 +3969,6 @@
     fmtprinting_class(timeinf)
     ncfobj.close()
+
+    return
 
 def sorttimesmat(filename, tname):
@@ -4151,91 +4014,5 @@
     ncft.close()
 
-def diffdate_units(diffdate, units):
-    """ Function to transform a difference of dates to a certain units
-    diffdate = difference of dates (as timedelta)
-    units = units to transform: 'weeks', 'days', 'hours', 'minutes', 'seconds', 'miliseconds', 'nanoseconds'
-    >>> diffdate_units(dt.datetime(1976, 2, 17, 8, 32, 5) - dt.datetime(1949, 12, 1, 0, 0, 0), 'seconds')
-    827224325.0
-    """
-    fname = 'diffdate_units'
-
-    if units == 'weeks':
-        diffunits = diffdate.days/7. + diffdate.seconds/(3600.*24.*7.)
-    elif units == 'days':
-        diffunits = diffdate.days + diffdate.seconds/(3600.*24.)
-    elif units == 'hours':
-        diffunits = diffdate.days*24. + diffdate.seconds/(3600.)
-    elif units == 'minutes':
-        diffunits = diffdate.days*24.*60. + diffdate.seconds/(60.)
-    elif units == 'seconds':
-        diffunits = diffdate.days*24.*3600. + diffdate.seconds
-    elif units == 'miliseconds':
-        diffunits = diffdate.days*24.*3600.*1000. + diffdate.seconds*1000.
-    elif units == 'nanoseconds':
-        diffunits = diffdate.days*24.*3600.*1000000. + diffdate.seconds*1000000.
-    else:
-        print errormsg
-        print fname + ': time units "' + units + '" not ready!!!'
-        print errormsg
-        quit(-1)
-
-    return diffunits
-
-def days_month(year,month):
-    """ Function to give the number of days of a month of a given year
-    >>> days_month(1976,2)
-    29
-    """
-    import datetime as dt
-
-    date1=dt.date(year,month,1)
-    date2=dt.date(year,month+1,1)
-
-    diffdate = date2-date1
-    return diffdate.days
-
-def mid_period(yr1,mon1,day1,hour1,min1,sec1,yr2,mon2,day2,hour2,min2,sec2):
-    """ Function to give the mid poiint of a period
-    >>> mid_period(1976,2,1,0,0,0,1976,3,1,0,0,0)
-    [1976    2   15   12    0    0]
-    """
-    import datetime as dt
-
-    date1=dt.datetime(yr1,mon1,day1,hour1,min1,sec1)
-    date2=dt.datetime(yr2,mon2,day2,hour2,min2,sec2)
-
-    diffdate = date2-date1
-    diffseconds = diffdate.days*24*3600 + diffdate.seconds
-    diff2 = dt.timedelta(seconds=diffseconds/2)
-    datenew = date1 + diff2
-    datenewvals = np.array([datenew.year, datenew.month, datenew.day, datenew.hour,  \
-      datenew.minute, datenew.second])
-
-    return datenewvals
-
-def days_year(year):
-    """ Function to give the number of days of a year
-    >>> days_year(1976)
-    366
-    """
-    import datetime as dt
-
-    date1=dt.date(year,1,1)
-    date2=dt.date(year+1,1,1)
-
-    diffdate = date2-date1
-    return diffdate.days
-
-def days_period(yeari,yearf):
-    """ Function to give the number of days for a period
-    >>> days_period(1976,1980)
-    1827
-    """
-
-    ndays=0    
-    for iyr in range(yearf-yeari+1):
-        ndays=ndays+days_year(yeari+iyr)
-
-    return ndays
+    return
 
 def check_times_file(values, filename, timen):
@@ -4356,4 +4133,6 @@
                 print matdates[it,:]
 
+    return
+
 def writing_str_nc(varo, values, Lchar):
     """ Function to write string values in a netCDF variable as a chain of 1char values
@@ -4445,92 +4224,4 @@
 
     return strings
-
-class ysubsetstats(object):
-    """ Class to compute multi-year statistics of a given subset of values 
-    values= values to use
-    dates=dates of the values in matrix format ([year], [month], [day], [hour], [minute], [second])
-    sec=section to use for the period='year', 'month', 'day', 'hour', 'minute', 'second'
-    vali=initial value of the period
-    valf=final value of the period
-    Nq= number of quantiles (20 for 5% bins, it is going to produce 21 values)
-    missval= missing value
-      self.Nvalues = Number of non masked values
-      self.min = minimum non masked value
-      self.max = maximum non masked value
-      self.mean = mean non masked value
-      self.mean2 = quandratic mean non masked value
-      self.stdev = standard deviation non masked value
-      self.quantiles = quantiles non masked value
-    """  
-    def __init__(self, values, dates, sec, vali, valf, Nq, missVal):
-        import numpy.ma as ma
-
-        fname = 'ysubsetstats'
-  
-        if values is None:
-            self.Nvalues = None
-            self.min = None
-
-            self.max = None
-            self.mean = None
-            self.mean2 = None
-            self.stdev = None
-            self.quantiles = None
-
-        else:
-            Nvalues = len(values)
-            Ndates = len(dates)
-
-            if Nvalues != Ndates:
-                print errormsg
-                print fname + ': number of values ', Nvalues,' does not coincide with the number of dates ',Ndates, '!!!!!!'
-                print errormsg
-                quit(-1)
-
-            initialsub = np.zeros(Nvalues, dtype=bool)
-            endsub = initialsub.copy()
-
-            if missVal > 0.:
-                valuesmask = ma.masked_greater_equal(values, missVal*0.9)
-            else:
-                valuesmask = ma.masked_less_equal(values, missVal*0.9)
-
-            if sec == 'year':
-                isec = 0
-            elif sec == 'month':
-                isec = 1
-            elif sec == 'day':
-                isec = 2
-            elif sec == 'hour':
-                isec = 3
-            elif sec == 'minute':
-                isec = 4
-            elif sec == 'second':
-                isec = 5
-            else:
-                print errormsg
-                print fname + ': sction "' + sec + '" not ready!!!!'
-                print errormsg
-                quit(-1)
-    
-            if vali < valf:
-                timesmaskperi = ma.masked_less(dates[:,isec], vali)
-                timesmaskperf = ma.masked_greater(dates[:,isec], valf)
-            else:
-                timesmaskperi = ma.masked_less(dates[:,isec], valf)
-                timesmaskperf = ma.masked_greater(dates[:,isec], vali)
-
-            finalmask = valuesmask.mask+timesmaskperi.mask+timesmaskperf.mask
-            finalvalues = ma.array(values, mask=finalmask)
-
-            finalvalues2 = finalvalues*finalvalues
-
-            self.Nvalues = finalvalues.count()
-            self.min = finalvalues.min()
-            self.max = finalvalues.max()
-            self.mean = finalvalues.mean()
-            self.mean2 = finalvalues2.mean()
-            self.stdev = finalvalues.std()
-            self.quantiles = mask_quantiles(finalvalues, Nq) 
 
 def remapnn(values, filename, varname):
@@ -4786,4 +4477,6 @@
 
     print 'remapnn: new file "' + ofile + '" with remapped variable written !!'
+
+    return
 
 #remapnn('met_em.d01.1979-01-01_00:00:00.nc|XLONG_M,XLAT_M|east_weast,south_north|longitude,latitude|longitude,latitude', \
@@ -4959,4 +4652,6 @@
 
     print 'remapnn: new file "' + ofile + '" with remapped variable written !!'
+
+    return
 #remapnn('data/R1_CCRC_NARCliM_MOM_1950-2009_pracc.nc:lon,lat:lon,lat', 'data/AWAP_pre_1950-2009_pre_mask.nc', 'pre', 1. , 1.)
 #quit()
@@ -5093,33 +4788,100 @@
     ncobj.close()
 
-def give_fix1dim_values(mat,iddim,dimval):
-    """ Function to return matrix values when one dimension has been removed at a 
-      given value
-    mat = matrix
-    iddim = dimesion to remove (starting from 0 tacking the right most)
-    dimval = value of the dimension
-
-    >>> matrix = np.array( (range(27)), dtype=np.float).reshape(3,3,3)
-    give_fix1dim_values(matrix,2,2)
-    [[[  0.   1.   2.]
-      [  3.   4.   5.]
-      [  6.   7.   8.]]
-
-     [[  9.  10.  11.]
-      [ 12.  13.  14.]
-      [ 15.  16.  17.]]]
+    return
+
+def valmod_dim(values, ncfile, varn):
+    """ Function to modify the value of a variable at a given dimension and value
+    values = dimn,dimval,modins,modval1,[modval2,...]
+      dimn = name of the dimension
+      dimval = value of the dimension at which change the values
+      modins = instruction: 
+        'sumc', add [modval1]
+        'subc', substraction [modval1]
+        'mulc', multiply by [modval1] 
+        'divc', divide by [modval1] 
+        'lowthres': modify all values below [modval1] to [modval2]
+        'upthres': modify all values above [modval1] to [modval2]
+    ncfile = netCDF file name
+    varn = name of the variable
+    >>> valmod_dim('num_metgrid_levels,10,mulc,-1','aqua_met-em_control.nc','PRES')
     """
-    fname='give_fix1dim_values'
-
-# Not working ma.squeeze
-##    import numpy.ma as ma
-##    print ma.squeeze(mat, axis = (idim,))
-    
-    matshape = mat.shape
-    mattype = mat.dtype
-    matmask = np.ones( tuple(matshape), dtype=bool)
+    fname = 'valmod_dim'
+
+    if values == '-h':
+        print """ Function to modify the value of a variable at a given dimension and value
+          values = dimn,dimval,modins,modval1,[modval2,...]
+          dimn = name of the dimension
+          dimval = value of the dimension at which change the values
+          modins = instruction: 
+            'sumc', add [modval1]
+            'subc', substraction [modval1]
+            'mulc', multiply by [modval1] 
+            'divc', divide by [modval1] 
+            'lowthres': modify all values below [modval1] to [modval2]
+            'upthres': modify all values above [modval1] to [modval2]
+          ncfile = netCDF file name
+          varn = name of the variable
+          >>> valmod_dim('num_metgrid_levels,10,mulc,-1','aqua_met-em_control.nc','PRES')
+          """
+        quit()
+
+##  mat = np.array( (range(27)), dtype=np.float).reshape(3,3,3)
+
+    vals = values.split(',')
+    Lvals = len(vals)
+
+    dimn = vals[0]
+    dimval = np.int(vals[1])
+    modins = vals[2]
+    modval = np.float(vals[3])
+    newvalues = ','.join(vals[2:Lvals])
+
+    if not os.path.isfile(ncfile):
+      print errormsg
+      print '   valmod: File "' + ncfile + '" does not exist !!'
+      print errormsg
+      quit(-1)    
+
+    ncf = NetCDFFile(ncfile,'a')
+
+    if ncf.dimensions.has_key('plev'):
+      # removing pressure level from variable name
+      varn = re.sub("\d+", "", varn) 
+
+    if not ncf.dimensions.has_key(dimn):
+      print errormsg
+      print '   ' + fname + ': File "' + ncfile + '" does not have dimension "' +    \
+        dimn + '" !!!!'
+      ncf.close()
+      quit(-1)
+
+    if not ncf.variables.has_key(varn):
+      print errormsg
+      print '   ' + fname + ': File "' + ncfile + '" does not have variable "' +     \
+        varn + '" !!!!'
+      ncf.close()
+      quit(-1)
+
+    varobj = ncf.variables[varn]
+    varinf = variable_inf(varobj)
+
+    varvals = varobj[:]
+
+# Dimension id
+    iddim=varinf.Ndims - 1
+    for idimn in varinf.dimns:
+#        print iddim, idimn
+        if dimn == idimn:
+            break
+
+        iddim = iddim - 1
+
+    matshape = varvals.shape
+    mattype = varvals.dtype
+    matmask = np.zeros( tuple(matshape), dtype=bool)
 
     zerodims=np.ones( (6), dtype=int)
     Ndims = len(matshape)
+
     if Ndims > 6: 
         print errmsg
@@ -5129,75 +4891,9 @@
     zerodims[5-Ndims+1:6] = matshape
 
-    newdims = list(matshape)
-    newdims[Ndims-1-iddim] = matshape[iddim]-1
-
-    mask = np.ones(tuple(zerodims), dtype=bool)
-    vals = np.zeros(tuple(zerodims), dtype=mattype)
-    vals[0:zerodims[0],0:zerodims[1],0:zerodims[2],0:zerodims[3],0:zerodims[4],
-      0:zerodims[5]] = mat
-
-    for i5 in range(zerodims[5]):
-        for i4 in range(zerodims[4]):
-            for i3 in range(zerodims[3]):
-                for i2 in range(zerodims[2]):
-                    for i1 in range(zerodims[1]):
-                        for i0 in range(zerodims[0]):
-#                            print 'iddim:',iddim,'dimval:',dimval,'-->',i0,i1,i2,i3,i4,i5
-                            if iddim == 5 and dimval == i0:
-                                mask[i0,i1,i2,i3,i4,i5] = False
-                            elif iddim == 4 and dimval == i1:
-                                mask[i0,i1,i2,i3,i4,i5] = False
-                            elif iddim == 3 and dimval == i2:
-                                mask[i0,i1,i2,i3,i4,i5] = False
-                            elif iddim == 2 and dimval == i3:
-                                mask[i0,i1,i2,i3,i4,i5] = False
-                            elif iddim == 1 and dimval == i4:
-                                mask[i0,i1,i2,i3,i4,i5] = False
-                            elif iddim == 0 and dimval == i5:
-                                mask[i0,i1,i2,i3,i4,i5] = False
-
-    newmat = vals[mask].reshape(tuple(newdims))
-#    print 'newmat dim:',iddim,'val:',dimval,':',newdims,'______'
-#    print newmat
-   
-    return newmat
-
-def portion_fix1dim_values(mat,iddim,dimval):
-    """ Function to return that portion of the matrix values when one dimension has
-      been removed at a given value
-    mat = matrix
-    iddim = dimesion to remove (starting from 0 tacking the right most)
-    dimval = value of the dimension
-
-    >>> matrix = np.array( (range(27)), dtype=np.float).reshape(3,3,3)
-    portion_fix1dim_values(matrix,2,2)
-    [[ 18.  19.  20.]
-     [ 21.  22.  23.]
-     [ 24.  25.  26.]]
-    """
-    fname='portion_fix1dim_values'
-
-# Not working ma.squeeze
-##    import numpy.ma as ma
-##    print ma.squeeze(mat, axis = (idim,))
-    
-    matshape = mat.shape
-    mattype = mat.dtype
-    matmask = np.zeros( tuple(matshape), dtype=bool)
-
-    zerodims=np.ones( (6), dtype=int)
-    Ndims = len(matshape)
-
-    if Ndims > 6: 
-        print errmsg
-        print '  ' + fname + ' number of dimensions: ',Ndims,' not ready!!!!!'
-        quit(-1)
-
-    zerodims[5-Ndims+1:6] = matshape
-
     newdims = []
     for idim in range(Ndims):
+#        print idim,'matshape[idim]:',matshape[Ndims-1-idim],'iddim:',iddim
         if idim != iddim:
-            newdims.append(matshape[idim])
+            newdims.append(matshape[Ndims-1-idim])
 
     newdims.reverse()
@@ -5205,6 +4901,10 @@
     mask = np.zeros(tuple(zerodims), dtype=bool)
     vals = np.zeros(tuple(zerodims), dtype=mattype)
-    vals[0:zerodims[0],0:zerodims[1],0:zerodims[2],0:zerodims[3],0:zerodims[4],
-      0:zerodims[5]] = mat
+    newvals = np.zeros(tuple(zerodims), dtype=mattype)
+
+    vals[0:zerodims[0],0:zerodims[1],0:zerodims[2],0:zerodims[3],0:zerodims[4],      \
+      0:zerodims[5]] = varvals
+
+#    print 'vals shape:',vals.shape,':',newdims
 
     for i5 in range(zerodims[5]):
@@ -5230,148 +4930,4 @@
 #    print 'newmat dim:',iddim,'val:',dimval,':',newdims,'______'
     newmat = vals[mask].reshape(tuple(newdims))
-#    print newmat
-   
-    return newmat
-
-def valmod_dim(values, ncfile, varn):
-    """ Function to modify the value of a variable at a given dimension and value
-    values = dimn,dimval,modins,modval1,[modval2,...]
-      dimn = name of the dimension
-      dimval = value of the dimension at which change the values
-      modins = instruction: 
-        'sumc', add [modval1]
-        'subc', substraction [modval1]
-        'mulc', multiply by [modval1] 
-        'divc', divide by [modval1] 
-        'lowthres': modify all values below [modval1] to [modval2]
-        'upthres': modify all values above [modval1] to [modval2]
-    ncfile = netCDF file name
-    varn = name of the variable
-    >>> valmod_dim('num_metgrid_levels,10,mulc,-1','aqua_met-em_control.nc','PRES')
-    """
-    fname = 'valmod_dim'
-
-    if values == '-h':
-        print """ Function to modify the value of a variable at a given dimension and value
-          values = dimn,dimval,modins,modval1,[modval2,...]
-          dimn = name of the dimension
-          dimval = value of the dimension at which change the values
-          modins = instruction: 
-            'sumc', add [modval1]
-            'subc', substraction [modval1]
-            'mulc', multiply by [modval1] 
-            'divc', divide by [modval1] 
-            'lowthres': modify all values below [modval1] to [modval2]
-            'upthres': modify all values above [modval1] to [modval2]
-          ncfile = netCDF file name
-          varn = name of the variable
-          >>> valmod_dim('num_metgrid_levels,10,mulc,-1','aqua_met-em_control.nc','PRES')
-          """
-        quit()
-
-##  mat = np.array( (range(27)), dtype=np.float).reshape(3,3,3)
-
-    vals = values.split(',')
-    Lvals = len(vals)
-
-    dimn = vals[0]
-    dimval = np.int(vals[1])
-    modins = vals[2]
-    modval = np.float(vals[3])
-    newvalues = ','.join(vals[2:Lvals])
-
-    if not os.path.isfile(ncfile):
-      print errormsg
-      print '   valmod: File "' + ncfile + '" does not exist !!'
-      print errormsg
-      quit(-1)    
-
-    ncf = NetCDFFile(ncfile,'a')
-
-    if ncf.dimensions.has_key('plev'):
-      # removing pressure level from variable name
-      varn = re.sub("\d+", "", varn) 
-
-    if not ncf.dimensions.has_key(dimn):
-      print errormsg
-      print '   ' + fname + ': File "' + ncfile + '" does not have dimension "' +    \
-        dimn + '" !!!!'
-      ncf.close()
-      quit(-1)
-
-    if not ncf.variables.has_key(varn):
-      print errormsg
-      print '   ' + fname + ': File "' + ncfile + '" does not have variable "' +     \
-        varn + '" !!!!'
-      ncf.close()
-      quit(-1)
-
-    varobj = ncf.variables[varn]
-    varinf = variable_inf(varobj)
-
-    varvals = varobj[:]
-
-# Dimension id
-    iddim=varinf.Ndims - 1
-    for idimn in varinf.dimns:
-#        print iddim, idimn
-        if dimn == idimn:
-            break
-
-        iddim = iddim - 1
-
-    matshape = varvals.shape
-    mattype = varvals.dtype
-    matmask = np.zeros( tuple(matshape), dtype=bool)
-
-    zerodims=np.ones( (6), dtype=int)
-    Ndims = len(matshape)
-
-    if Ndims > 6: 
-        print errmsg
-        print '  ' + fname + ' number of dimensions: ',Ndims,' not ready!!!!!'
-        quit(-1)
-
-    zerodims[5-Ndims+1:6] = matshape
-
-    newdims = []
-    for idim in range(Ndims):
-#        print idim,'matshape[idim]:',matshape[Ndims-1-idim],'iddim:',iddim
-        if idim != iddim:
-            newdims.append(matshape[Ndims-1-idim])
-
-    newdims.reverse()
-
-    mask = np.zeros(tuple(zerodims), dtype=bool)
-    vals = np.zeros(tuple(zerodims), dtype=mattype)
-    newvals = np.zeros(tuple(zerodims), dtype=mattype)
-
-    vals[0:zerodims[0],0:zerodims[1],0:zerodims[2],0:zerodims[3],0:zerodims[4],      \
-      0:zerodims[5]] = varvals
-
-#    print 'vals shape:',vals.shape,':',newdims
-
-    for i5 in range(zerodims[5]):
-        for i4 in range(zerodims[4]):
-            for i3 in range(zerodims[3]):
-                for i2 in range(zerodims[2]):
-                    for i1 in range(zerodims[1]):
-                        for i0 in range(zerodims[0]):
-#                            print 'iddim:',iddim,'dimval:',dimval,'-->',i0,i1,i2,i3,i4,i5
-                            if iddim == 5 and dimval == i0:
-                                mask[i0,i1,i2,i3,i4,i5] = True
-                            elif iddim == 4 and dimval == i1:
-                                mask[i0,i1,i2,i3,i4,i5] = True
-                            elif iddim == 3 and dimval == i2:
-                                mask[i0,i1,i2,i3,i4,i5] = True
-                            elif iddim == 2 and dimval == i3:
-                                mask[i0,i1,i2,i3,i4,i5] = True
-                            elif iddim == 1 and dimval == i4:
-                                mask[i0,i1,i2,i3,i4,i5] = True
-                            elif iddim == 0 and dimval == i5:
-                                mask[i0,i1,i2,i3,i4,i5] = True
-
-#    print 'newmat dim:',iddim,'val:',dimval,':',newdims,'______'
-    newmat = vals[mask].reshape(tuple(newdims))
     varmod = np.zeros(tuple(newdims), dtype=mattype) 
 
@@ -5413,4 +4969,6 @@
     ncf.sync()
     ncf.close()
+
+    return
 
 def checkNaNs(values, filen):
@@ -5513,4 +5071,6 @@
     ncobj.close()
 
+    return
+
 ##checkNaNs(10.e10, '/d4/lflmd/etudes/WRF_LMDZ/WaquaL/WRF/control/wrfout_d01_1979-12-01_00:00:00')
 ##checkNaNs(10.e10, '/d4/lflmd/etudes/FF/tests/em_quarter_ss/run/wrfout_d01_0001-01-01_00:00:00')
@@ -5549,4 +5109,6 @@
 
     ncobj.close()
+
+    return
 
 ##checkAllValues(0., '/d4/lflmd/etudes/WRF_LMDZ/WaquaL/WRF/control/wrfout_d01_1979-12-01_00:00:00')
@@ -6110,5 +5672,4 @@
 
     return
-
 
 def sellonlatboxold(values, ncfile, varn):
@@ -7009,80 +6570,4 @@
 #compute_opervaralltime('add|time', 'obs/PRCP.nc', 'product')
 
-def retype(val, vtype):
-    """ Function to transform a value to a given type
-    retype(val, vtype)
-      [val]= value
-      [vtype]= type to transform
-    >>> retype(0, type(True))
-    False
-    """
-
-    fname = 'retype'
-
-    if val == 'h':
-        print fname + '_____________________________________________________________'
-        print retype.__doc__
-        quit()
-
-    if vtype == type(int(1)):
-        newval = int(val)
-    elif vtype == type(float(1)):
-        newval = float(val)
-#    elif vtype == type(float32(1)):
-#        newval = float32(val)
-    elif vtype == type(np.int(1)):
-        typeinf = np.iinfo(np.int)
-        if (abs(np.float64(val)) > typeinf.max):
-            print warnmsg
-            print '  ' + fname + ': value to transform ', val,' overpasses type:',   \
-               vtype,' limits!!'
-            print '  Changing value to kind largest allowed value:', typeinf.max
-            newval = abs(np.float64(val))/np.float64(val) * np.int(typeinf.max)
-        else:
-            newval = np.int(val)
-    elif vtype == type(np.int16(1)):
-        typeinf = np.iinfo(np.int16)
-        if (abs(np.float64(val)) > typeinf.max):
-            print warnmsg
-            print '  ' + fname + ': value to transform ', val,' overpasses type:',   \
-               vtype,' limits!!'
-            print '  Changing value to kind largest allowed value:', typeinf.max
-            newval = abs(np.float64(val))/np.float64(val) * np.int16(typeinf.max)
-        else:
-            newval = np.int16(val)
-    elif vtype == type(np.int32(1)):
-        typeinf = np.iinfo(np.int32)
-        if (np.abs(np.float64(val)) > typeinf.max):
-            print warnmsg
-            print '  ' + fname + ': value to transform ', val,' overpasses type:',   \
-               vtype,' limits!!'
-            print '  Changing value to kind largest allowed value:', typeinf.max
-            newval = abs(np.float64(val))/np.float64(val) * np.int32(typeinf.max)
-        else:
-            newval = np.int32(np.float64(val))
-    elif vtype == type(np.int64(1)):
-        newval = np.int64(val)
-    elif vtype == type(np.float(1)):
-        newval = np.float(val)
-#    elif vtype == type(np.float16(1)):
-#        newval = np.float16(val)
-    elif vtype == type(np.float32(1)):
-        newval = np.float32(val)
-    elif vtype == type(np.float64(1)):
-        newval = np.float64(val)
-    elif vtype == type(True):
-        if val == 0:
-            newval = False
-        else:
-            newval = True
-    elif vtype == '|S1':
-        newval = str(val)
-    else:
-        print errormsg
-        print '  ' + fname + ': variable type "', vtype, '" not ready!!!'
-        quit(-1)
-
-    return newval
-
 def setvar_asciivalues(values, ncfile, varname):
     """ Function to set de values of a variable with an ASCII file (common 
